100 ' Zahnradgenerator fr AutoCAD
110 ' Erzeugt anhand der eingegebenen Werte ein DXF-File,
120 ' das mit "DXFIN" in die CAD-Zeichnung hinzugefgt werden kann
130 ' Version 2.0
140 ' nderungen gegenber Version 1.0:
150 ' - Korrektur und damit V-Verzahnung hinzugefgt
160 ' - Vorgelege aus mehreren Rdern kann generiert werden
170 ' - Schrgungswinkel  kann spezifiziert werden
180 ' (c) 1990, 1998 by Andreas Meile, CH-8242 Hofen SH
190 ' e-Mail: ia95meil@htl-bw.ch  WWW: http://www.htl-bw.ch/~ia95meil/
200 :
210 ' S e h r   w i c h t i g : Da AutoCAD intern mit 14 signifikanten
220 '                           Stellen arbeitet, wird zur Fileerzeugung die
230 '                           doppeltgenaue Gleitkommaarithmetik eingesetzt.
240 '                           Da zur Zahnradberechnung Trigonometrie bentigt
250 '                           wird, muss der BASIC-Interpreter mit "/D" gela-
260 '                           den werden!
270 :
280 ' Test, ob der BASIC-Interpreter mit "/D" geladen wurde
290 :
300 IF LEN(STR$(SIN(1#)))>10 THEN 340
310 PRINT "Beim Laden des BASIC-Interpreters wurde ";CHR$(34);"/D";CHR$(34);" vergessen."
320 PRINT "Bitte den BASIC-Interpreter mit angehngten ";CHR$(34);"/D";CHR$(34);" neustarten!"
330 SYSTEM
340 ' Konstante 
350 PI#=4#*ATN(1#)
360 CLS
370 PRINT "   *** CAD-Zahnrad fr AutoCAD ***"
380 PRINT "V2.0 (c) 1990, 1998 by Andreas Meile, CH-8242 Hofen SH"
390 PRINT "Erzeugt anhand der eingegebenen Werte ein DXF-File,"
400 PRINT "das mit ";CHR$(34);"DXFIN";CHR$(34);" in eine CAD-Zeichnung hinzugefgt werden kann."
410 PRINT "Elementart: geschlossene Polylinie"
420 PRINT
430 INPUT "Mittelpunkt ";LX#,LY#
440 INPUT "Stellung des 1. Zahnes (Winkel in ) ";LAL#
450 INPUT "Modul (Normalmodul, d.h. vom Werkzeug) ";M#
460 IF M#<=0# THEN PRINT "Ungltig!":GOTO 450
470 INPUT "Zhnezahl ";Z%
480 IF Z%<1 THEN PRINT "Ungltig!":GOTO 470
490 INPUT "Korrektur (0=unkorrigiert) "; X#
500 INPUT "Schrgungswinkel in  (0=Geradverzahnung)";BET#
510 INPUT "Eingriffswinkel in  (nach Norm 20) ";AL#
520 INPUT "Dateiname (inkl. Laufwerk und Pfad, jedoch ohne Suffix!) ";DN$
530 OPEN DN$+".DXF" FOR OUTPUT AS 1
540 PRINT#1,0:PRINT#1,"SECTION"
550 PRINT#1,2:PRINT#1,"ENTITIES"
560 ' Ab hier wiederholende Eingaben
570 INPUT "Kopfhhenfaktor (nach Norm 1) ";HAF#
580 INPUT "Fusshhenfaktor (nach Norm 1.25) ";HFF#
590 INPUT "Zeichengenauigkeit der Zahnflanken-Evolvente (Anzahl Linien) ";GEN%
600 IF GEN%<1 THEN PRINT "Ungltig!":GOTO 590
610 INPUT "Layername in der entsprechenden CAD-Zeichnung (z.B. 07930000) ";LA$
620 GOSUB 2000
630 PRINT "Mittelpunkt eines weiteren Rades oder Leereingabe (Return alleine)"
640 LINE INPUT "fr Ende (AutoCAD-Syntax!)? ",H$
650 IF H$="" THEN 800
660 REL%=LEFT$(H$,1)="@":IF REL% THEN H$=MID$(H$,2)
670 KAR%=INSTR(H$,","):IF KAR%=0 THEN 700
680 NLX#=VAL(LEFT$(H$,KAR%-1)):NLY#=VAL(MID$(H$,KAR%+1))
690 GOTO 730
700 POL%=INSTR(H$,"<"):IF POL%=0 THEN PRINT "Ungltig!":GOTO 630
710 R#=VAL(LEFT$(H$,POL%-1)):PHI#=VAL(MID$(H$,POL%+1))/180#*PI#
720 NLX#=R#*COS(PHI#):NLY#=R#*SIN(PHI#)
730 IF REL% THEN NLX#=NLX#+LX#:NLY#=NLY#+LY#
740 INPUT "Zhnezahl (0=automatisch, so dass nahe bei V-Null)";NZ%
750 GOSUB 5000
760 PRINT "Gewhlte Zhnezahl:";NZ%
770 PRINT "Gewhlte Korrektur:";X#
780 GOTO 570
790 ' Dateiabschluss
800 PRINT#1,0:PRINT#1,"ENDSEC"
810 PRINT#1,0:PRINT#1,"EOF"
820 CLOSE 1
830 :
840 SYSTEM
850 :
2000 ' Unterprogramm ZeichneZahnrad
2010 :
2020 ' Eingangsparameter (Variablen):
2030 ' lx#,ly# : Mittelpunkt des Zahnrades auf dem Bildschirm
2040 ' m#      : Modul des Zahnrades (in Bildpunkten!)
2050 ' z%      : Zhnezahl des Zahnrades
2060 ' x#      : Profilverschiebungsfaktor (0=unkorrigiert)
2070 ' Bet#    : Schrgungswinkel in  (0=Geradverzahnung)
2080 ' hff#    : Fusshhenfaktor (bei genormten Rder normalerweise 1.25)
2090 ' haf#    : Kopfhhenfaktor (bei genormten Rder normalerweise 1)
2100 ' Al#     : Eingriffswinkel in  (bei genormten Rder normalerweise 20)
2110 ' lAl#    : Lagewinkel des ersten Zahnes in 
2120 ' Gen%    : Zeichengenauigkeit der Evolvente (Anzahl Linien)
2130 ' La$     : Layer in der AutoCAD-Zeichnung (z.B. 07930000)
2140 :
2150 PRINT#1,0
2160 PRINT#1,"POLYLINE"
2170 PRINT#1,8
2180 PRINT#1,LA$
2190 PRINT#1,66
2200 PRINT#1,"    1"
2210 PRINT#1,70
2220 PRINT#1,"    1"
2230 LALR#=LAL#/180#*PI#
2240 ALR#=AL#/180#*PI#
2250 BETR#=BET#/180#*PI#
2260 D#=M#*CDBL(Z%)/COS(BETR#)
2270 IF HFF#>CDBL(Z%)/2#/COS(BETR#) THEN HFF#=CDBL(Z%)/2#/COS(BETR#)
2280 DF#=D#-2#*M#*(HFF#-X#)
2290 DA#=D#+2#*M#*(HAF#+X#)
2300 TGALS#=TAN(ALR#)/COS(BETR#)
2310 DG#=D#/SQR(1#+TGALS#*TGALS#)
2320 IF DF#<DG# THEN E%=-1:SWFR#=0# ELSE E%=0:SWFR#=SQR(DF#*DF#-DG#*DG#)/DG#
2330 SWAR#=SQR(DA#*DA#-DG#*DG#)/DG#
2340 TEILW#=2#*PI#/CDBL(Z%)
2350 WW#=TEILW#/4#-ATN(TGALS#)+TGALS#+2#*X#*TAN(ALR#)/CDBL(Z%)
2360 WFR#=WW#-SWFR#+ATN(SWFR#)
2370 WAR#=WW#-SWAR#+ATN(SWAR#)
2380 ABA#=TAN(WAR#/2#)
2390 ABF#=TAN(TEILW#/4#-WFR#/2#)
2400 F%=WFR#<TEILW#/2#
2410 A%=WAR#>0#
2420 IF A% THEN 2480
2430 SWAR#=1024#:H#=512#
2440 FOR I%=0 TO 80
2450 IF SWAR#-WW#>ATN(SWAR#) THEN SWAR#=SWAR#-H# ELSE SWAR#=SWAR#+H#
2460 H#=H#/2#
2470 NEXT I%
2480 IF F% THEN 2540
2490 SWFR#=1024#:H#=512#
2500 FOR I%=0 TO 80
2510 IF SWFR#-WW#+TEILW#/2#>ATN(SWFR#) THEN SWFR#=SWFR#-H# ELSE SWFR#=SWFR#+H#
2520 H#=H#/2#
2530 NEXT I%
2540 R#=DG#/2#
2550 SW#=(SWAR#-SWFR#)/CDBL(GEN%)
2560 S#=LALR#+WAR#
2570 FOR ZAHN%=0 TO Z%-1
2580 LWR#=LALR#+TEILW#*CDBL(ZAHN%)
2590 SWR#=-SWAR#
2600 W#=LWR#+WW#
2610 GOSUB 2940
2620 IF NOT F% THEN 2840
2630 E1#=LWR#+TEILW#-WFR#
2640 IF NOT E% THEN 2740
2650 S1#=LWR#+WFR#
2660 PRINT#1,0:PRINT#1,"VERTEX"
2670 PRINT#1,8:PRINT#1,LA$
2680 PRINT#1,10:H$=STR$(LX#+DF#/2#*COS(S1#)):B%=INSTR(H$,"D")
2690 IF B% THEN MID$(H$,B%)="E"
2700 PRINT#1,H$
2710 PRINT#1,20:H$=STR$(LY#+DF#/2#*SIN(S1#)):B%=INSTR(H$,"D")
2720 IF B% THEN MID$(H$,B%)="E"
2730 PRINT#1,H$
2740 AB#=ABF#:R1#=DF#/2#:GOSUB 3070
2750 IF NOT E% THEN 2840
2760 PRINT#1,0:PRINT#1,"VERTEX"
2770 PRINT#1,8:PRINT#1,LA$
2780 PRINT#1,10:H$=STR$(LX#+R#*COS(E1#)):B%=INSTR(H$,"D")
2790 IF B% THEN MID$(H$,B%)="E"
2800 PRINT#1,H$
2810 PRINT#1,20:H$=STR$(LY#+R#*SIN(E1#)):B%=INSTR(H$,"D")
2820 IF B% THEN MID$(H$,B%)="E"
2830 PRINT#1,H$
2840 SWR#=SWFR#
2850 W#=LWR#-WW#+TEILW#
2860 GOSUB 2940
2870 E1#=LWR#+TEILW#+WAR#
2880 AB#=ABA#:R1#=DA#/2#:IF A% THEN GOSUB 3070
2890 NEXT ZAHN%
2900 PRINT#1,0:PRINT#1,"SEQEND"
2910 PRINT#1,8:PRINT#1,LA$
2920 RETURN
2930 :
2940 FOR I%=1 TO GEN%
2950 A#=W#+SWR#+CDBL(I%)*SW#:B#=(A#-W#)*R#
2960 PRINT#1,0:PRINT#1,"VERTEX"
2970 PRINT#1,8:PRINT#1,LA$
2980 PRINT#1,10:H$=STR$(LX#+R#*COS(A#)+B#*SIN(A#)):B%=INSTR(H$,"D")
2990 IF B% THEN MID$(H$,B%)="E"
3000 PRINT#1,H$
3010 PRINT#1,20:H$=STR$(LY#+R#*SIN(A#)-B#*COS(A#)):B%=INSTR(H$,"D")
3020 IF B% THEN MID$(H$,B%)="E"
3030 PRINT#1,H$
3040 NEXT I%
3050 RETURN
3060 :
3070 PRINT#1,42:H$=STR$(AB#):B%=INSTR(H$,"D")
3080 IF B% THEN MID$(H$,B%)="E"
3090 PRINT#1,H$
3100 PRINT#1,0:PRINT#1,"VERTEX"
3110 PRINT#1,8:PRINT#1,LA$
3120 PRINT#1,10:H$=STR$(LX#+R1#*COS(E1#)):B%=INSTR(H$,"D")
3130 IF B% THEN MID$(H$,B%)="E"
3140 PRINT#1,H$
3150 PRINT#1,20:H$=STR$(LY#+R1#*SIN(E1#)):B%=INSTR(H$,"D")
3160 IF B% THEN MID$(H$,B%)="E"
3170 PRINT#1,H$
3180 RETURN
3190 :
5000 ' Unterprogramm BerechneNeulage
5010 :
5020 ' Eingangsparameter (Variablen):
5030 ' lx#,ly#,m#,
5040 ' z%,lAl#,x#  : Alte Werte; diese werden entsprechend nachgefhrt
5050 ' nz%         : Neue Zhnezahl; beim Wert 0 berechnet das Pro-
5060 '             : gramm eine Zhnezahl, die mglichst nahe an
5070 '             : die V-Null-Verzahnung herankommt; der Korrek-
5080 '             : turfaktor wird dabei automatisch angepasst
5090 ' nlx#, nly#  : Mittelpunkt des eingreifenden Rades
5100 :
5110 DX#=NLX#-LX#:DY#=NLY#-LY#
5120 ALR#=AL#/180#*PI#
5130 BETR#=BET#/180#*PI#
5140 A#=SQR(DX#*DX#+DY#*DY#)
5150 IF NZ%=0 THEN NZ%=CINT(2#*A#*COS(BETR#)/M#)-Z%
5160 TGALS#=TAN(ALR#)/COS(BETR#)
5170 COALB#=M#/COS(BETR#)*CDBL(Z%+NZ%)/SQR(1#+TGALS#*TGALS#)/2#/A#
5180 TGALB#=SQR(1#-COALB#*COALB#)/COALB#
5190 X#=CDBL(Z%+NZ%)*((TGALB#-ATN(TGALB#)+ATN(TGALS#))/TGALS#-1#)/COS(BETR#)/2#-X#
5200 IF DX#<>0# THEN 5230
5210 IF DY#>0# THEN W#=90# ELSE W#=270#
5220 GOTO 5240
5230 W#=ATN(DY#/DX#)*180#/PI#:IF DX#<0# THEN W#=W#+180#
5240 LAL#=W#-180#+180#/CDBL(NZ%)+(W#-LAL#)*CDBL(Z%)/CDBL(NZ%)
5250 LX#=NLX#:LY#=NLY#:Z%=NZ%
5260 RETURN
